/**************************************************************************************
 ** Class name: Menus
 ** Author: A.J. Lattanze, CMU
 ** Date: 12/29/99
 ** Version 1.0
 **
 ** Adapted for use at ETS by Roger Champagne, 2002-May-21
 ***************************************************************************************
 ** Purpose: Assignment 2 for LOG420, Architecture et conception de logiciels.
 ** This class is presents the user with menus, accepts their choice, ensures their
 ** choice is valid, and returns their choice to the caller.
 **
 ** Abstract: There are several menus that can be presented as follows:
 **
 **	MainMenu() - The MainMenu() method presents the following menu choices:
 **
 **		1) List Students
 **		2) List Courses
 **		3) List Courses a Student has Registered for
 **		4) List Students Registered for a Course
 **		5) Register a Student for a Course
 **		X) Exit
 **
 ** 
 **		
 ** Modification Log
 **************************************************************************************
 **
 **************************************************************************************/

public class Menus {

    public char MainMenu() {

        Termio Terminal = new Termio();
        char UserChoice = ' ';
        boolean Error = true;

        while (Error) {

            System.out.println("\n\n1) List Students");
            System.out.println("2) List Courses");
            System.out.println("3) List Courses a Student has Registered for");
            System.out.println("4) List Students Registered for a Course");
            System.out.println("5) Register a Student for a Course");
            System.out.println("X) Exit");
            System.out.print("\n\nEnter your choice and press return >> ");

            UserChoice = Terminal.KeyboardReadChar();

            if ((UserChoice != 'X')
                && (UserChoice != 'x')
                && (UserChoice < '1')
                && (UserChoice != '2')
                && (UserChoice != '3')
                && (UserChoice < '4')
                && (UserChoice != '5')) {

                System.out.print(
                    "\n\n*** Invalid Choice:: " + UserChoice + " ***");

            } else {

                Error = false;

            } // if

        } // while

        return (UserChoice);

    } // MainMenu

    public Student PickStudent(StudentList ListObject) {

        Termio Terminal = new Termio();
        String UserChoice;
        Student StudentObject = null;

        System.out.print("\n\nEnter Student ID and press return >> ");
        UserChoice = Terminal.KeyboardReadString();

        StudentObject = ListObject.FindStudentByID(UserChoice);

        if (StudentObject == null) {

            System.out.println(
                "\n\n*** Student ID " + UserChoice + " not found ***");

        } // if 

        return (StudentObject);

    } // PickStudent

    public Course PickCourse(CourseList ListObject) {

        Termio Terminal = new Termio();
        String UserChoiceCourseID;
        String UserChoiceSection;
        Course CourseObject = null;

        System.out.print("\n\nEnter Course ID and press return >> ");
        UserChoiceCourseID = Terminal.KeyboardReadString();

        System.out.print("\n\nEnter Course Section and press return >> ");
        UserChoiceSection = Terminal.KeyboardReadString();

        CourseObject =
            ListObject.FindCourseByIDAndSection(
                UserChoiceCourseID,
                UserChoiceSection);

        if (CourseObject == null) {
            System.out.print("\n\n*** Course ID:" + UserChoiceCourseID);
            System.out.println(
                " Section:" + UserChoiceSection + " not found ***");

        } // if 

        return (CourseObject);

    } // PickCourse

} // Menus
