/**************************************************************************************
** Class name: Student
** Author: A.J. Lattanze, CMU
** Date: 12/29/99
** Version 1.0
**
** Adapted for use at ETS by Roger Champagne, 2002-May-21
***************************************************************************************
** Purpose: Assignment 2 for LOG420, Architecture et conception de logiciels.
** This class defines the Student object for the system.
**
** Abstract: This class describes a Student object.  Besides the static attributes,
** there are two lists maintained as follows:
**
**	CoursesTakenList - This is a CourseList object that maintains a list of courses
**	that the student has taken.
**	
**	CoursesRegistered - This is also a CourseList object that maintains a list of
**	courses that the student has registered for.
**
** There is one method in this class:
**
** 	Register( Course CourseObject ) - This method registers a student for a course 
**	by adding a student for a course.
**
** Modification Log
**************************************************************************************
**
**************************************************************************************/

class Student {

    String LastName; // Student's Last Name
    String FirstName; // Student's First Name
    String StudentID; // Students identification number
    String Program; // Program of study

    // List of courses taken by the student
    CourseList CoursesTakenList = new CourseList();

    // List of courses the student is registered for
    CourseList CoursesRegistered = new CourseList();

    public void Register(Course CourseObject) {

        CoursesRegistered.AddCourse(CourseObject);

    } // Register

} // Student class
